        /* -------------------------------------------------------
         Scripts en javascript
         Licence CeCILL v2.1
         Auteur E. DELATTRE
         Révision 20160822.ED
         ------------------------------------------------------*/

// Fontions de l'application

        function Initgroupe() {
            /* -------------------------------------------------------
             Objet:    initialise la liste de selection des groupes à partir du tableau RPTgroupe[].
             Commentaires: 
             Effets:   Modifie le contenu de la liste de sélection "RPT_groupe"
             Entrées:  Utilise le tableau global RPTgroupe[]
             Retours:  aucun.
             Version 1.0.0
             Révision 20160809 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/
            var x,i,option;
            x = document.getElementById('RPT_groupe');
            x.length=0; // vide le select RPT_groupe: ne fonctionne pas correctement, 
            for (i = 0; i < RPTgroupe.length; i++)  // ajoute les élément de RPTgroupe dans le select "RPT_groupe"
            {
              option = document.createElement('option');
              option.value = i;
              option.text = RPTgroupe[i];
              x.add(option);
            }
            x.selectedIndex=0; //selectionne le premier élément du select "RPT_groupe"
            Inittype();
        }

        function Inittype() {
            /* -------------------------------------------------------
             Objet:    crée l la lise des types du tableau RPTtype[] définis pour le groupe choisi parmi ceux définis dans RPT[] pour le RTP_groupe sélectionné.
             Commentaires: Filtre le tableau RPT[]
             Effets:   Modifie le contenu du select RPT_type
             Entrées:  Utilise la liste de sélection "RPT_groupe"
             Retours:  aucun.
             Version 1.0.0
             Révision 20160809 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/
            var x = document.getElementById('RPT_groupe').selectedIndex; // récupère l'index sélectionné dans la liste des groupes
            var y = document.getElementById('RPT_groupe').options; // récupère les options de référentiel
            var i=0;
            var j=0;
            var k=0;
            var l=0;
            var m=0;
            var Idxgrp=y[x].index;
            var typedontexist=true;
            var RPTF1 =[];
            RPTF1.length=0; //on vide RPTF1
            // filtre des index correspondant au groupe
            for (i = 0; i < RPT.length; i++)  {// on passe tout le tableau en revue
              if (RPT[i][0]== Idxgrp ) { //l'IdxGroupe est celui qui a été sélectionné, on passe à la récupération des idxtype du groupe
                for (j = 0; j < RPTtype.length; j++) { // pour chaque type, on regade si le groupe est le bon.
                  if (RPTtype[RPT[i][1]]==RPTtype[j]) { //on a un idxtype du RTP du groupe qui est dans RTPtype[]
                    if (k==0) { // c'est le premier idxtype trouvé, on le stocke
                      RPTF1[0]=j;
                      k++;                        
                    }else{ // il y a déjà au moins un idxtype trouvé
                      typedontexist=true; //on présuppose qu'il n'est pas dans la liste des idxtype trouvés
                      for (l=0;l<RPTF1.length;l++){ //on passe en revue tous les idxtype trouvés
                        if (RPTF1[l]==j) {// si l'idxtype a déjà été trouvé
                          typedontexist=false; //alors il existe dans la liste des types du groupe                       
                        }
                      }
                      if (typedontexist==true){ //Si l'idxtype n'existe pas dans la liste
                        RPTF1[k]=j; //on l'ajoute à la liste des idxtype du groupe
                        k++;
                      }
                    }
                  }
                } 
              } 
            }
            //document.getElementById('NbExamRef').innerHTML=NRDF0.length;
            x = document.getElementById('RPT_type');
            x.disabled=false;
            x.length=0; // vide le select referentiel: ne fonctionne pas correctement,
            // récupération des indices des types définis dans RPT[] pour le groupe sélectionné
            for (i = 0; i < RPTF1.length; i++)  // ajoute les élément de RPTtype dans le select "RPT_type"
            {
              option = document.createElement('option');
              option.value = RPTF1[i];
              option.text = RPTtype[RPTF1[i]];
              x.add(option);
            }
            x.selectedIndex=0; //selectionne le premier élément du select "RPT_Type"
            Initlimits();
        }

        function Initlimits() {
            /* -------------------------------------------------------
             Objet:    initialise la liste de selection des examens à partir du tableau NRD[].
             Commentaires: 
             Effets:   Modifie le contenu de la liste de sélection "examen"
             Entrées:  Utilise le tableau global RPT[] et NRDF1
             Retours:  aucun.
             Version 1.0.1
             Révision 20160816 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/
            var x,i,option;
            var x0 = document.getElementById('RPT_groupe').selectedIndex; // récupère l'index sélectionné dans la liste des groupes
            var y0 = document.getElementById('RPT_groupe').options; // récupère les options de groupe
            var x1 = document.getElementById('RPT_type').selectedIndex; // récupère l'index sélectionné dans la liste des types
            var y1 = document.getElementById('RPT_type').options; // récupère les options de type
            var x3 = document.getElementById('RPT_limits');
            x3.disabled=false;
            x3.length=0; // vide le select referentiel: ne fonctionne pas correctement,
            var i=0;
            var j=y0[x0].index;
            var k=y1[x1].value;
            var l=0;
            var RPTF0 = [];
            // filtre des index correspondant au groupe
            for (i = 0; i < RPT.length; i++)  {// on passe tout le tableau en revue
              //alert("RPT["+i+"][0]="+RPT[i][0]+"="+j+"; RPT["+i+"][1]="+RPT[i][1]+"="+k);
              if((RPT[i][0]==j)&&(RPT[i][1]==k)){
                RPTF0[l]=i;
                l++;
              }
            } //RPTF0 contient maintenant la liste des indices des limites possibles
            for (i = 0; i < RPTF0.length; i++)  {  // ajoute les élément de RPT dans le select "RPT_limits"
              option = document.createElement('option');
              option.value = RPTF0[i];//on met les indices de RPT dans la value
              option.text = RPT[RPTF0[i]][2]; //on met le nom de l'organe choisi dans le texte
              x3.add(option);
            }
            x3.selectedIndex=0; //selectionne le premier élément du select "RPT_Type"
            Afflimit();
        }

        function Initoper() {
            /* -------------------------------------------------------
             Objet:    initialise la liste de selection des modes d'exposition à partir du tableau RPTopt[].
             Commentaires: 
             Effets:   Modifie le contenu de la liste de sélection "RPT_opt"
             Entrées:  Utilise le tableau global RPTopt[]
             Retours:  aucun.
             Version 1.0.0
             Révision 20160809 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/
            var x,i,option;
            x = document.getElementById('RPT_opt');
            x.disabled=false;
            x.length=0; // vide le select RPT_opt: ne fonctionne pas correctement, 
            for (i = 0; i < (RPTopt.length/2); i++)  // ajoute les élément de RPTopt dans le select "RPT_opt"
            {
              option = document.createElement('option');
              option.value = RPTopt[2*i+1];
              option.text = RPTopt[2*i];
              x.add(option);
            }
            x.selectedIndex=0; //selectionne le premier élément du select "RPT_groupe"
        }

        function Afflimit() {
            /* -------------------------------------------------------
             Objet:    affiche la ou les valeurs de limite de dose dans le cas sélectionné
             Commentaires: 
             Effets:   Modifie le contenu de "RPT_value" et l'input "RPT_unit"
             Entrées:  Utilise le tableau global RPT[] et la limite sélectionnée
             Retours:  aucun.
             Version 1.0.0
             Révision 20160809 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/
            var x,txt;
            var x = document.getElementById('RPT_limits');
            RPTIdx = x.options[x.selectedIndex].value; //récupère l'indice du tableau RPT correspondant à la limite selectionnée
            //on réinitialise l'affichage
            txt = "";
            document.getElementById('RPT_value').innerHTML = "";
            txt = "Dose "+RPT[RPTIdx][3]+" : "+RPT[RPTIdx][4]+" "+RPT[RPTIdx][5];
            if (RPT[RPTIdx][6]!=-1){
              txt += "  sur une période de "+RPT[RPTIdx][6];
            }
            txt+= " "+RPT[RPTIdx][7];
            document.getElementById('RPT_value').innerHTML = txt;
            // information sur la catégorie de personnel généralement concerné
            document.getElementById('RPT_cat').innerHTML = "";
            document.getElementById('RPT_cat').innerHTML = RPT[RPTIdx][8];
            // valeur et unité du relevé de dose à comparer
             document.getElementById('RPT_your_dose').innerHTML = "";
             document.getElementById('RPT_your_dose').innerHTML = "Dose "+RPT[RPTIdx][3]+" : ";
             document.getElementById('RPT_your_value').value = RPT[RPTIdx][4];
             document.getElementById('RPT_your_unit').innerHTML = "";
             document.getElementById('RPT_your_unit').innerHTML = RPT[RPTIdx][5];
            Calclimit();
        }


        function Calclimit (){
            /* -------------------------------------------------------
             Objet:    comparaison limite/ mesure et affichage de recommandations.
             Commentaires: selon valeur et paramètres, OK, actions correctives ou déclaration ASN 
             Effets:   Modifie les commentaires
             Entrées:  Utilise le RPTcom[]
             Retours:  aucun.
             Version 1.0.0
             Révision 20160809 par E. DELATTRE
             Auteur:   E. DELATTRE
             -------------------------------------------------------*/

            var ObjCom = document.getElementById('RPT_commentaires');
            var YourDose = document.getElementById('RPT_your_value').value;
            ObjCom.innerHTML = RPTcom[0];
            var x = document.getElementById('RPT_limits');
            var RPTIdx = x.options[x.selectedIndex].value; //récupère l'indice du tableau RPT correspondant à la limite selectionnée
            var y = document.getElementById('RPT_opt');
            var Coefdec = y.options[y.selectedIndex].value; //récupère la valeur de coef à appliquer indiqué dans les documents ASN pour la déclaration (=1 ou 0.25)
            if (YourDose > (RPT[RPTIdx][4]*Coefdec)){
              ObjCom.innerHTML = RPTcom[1]+" (critère: dose >"+Coefdec+" x la limite)";
            }
        }
